#ifndef COVERSCORE_H
#define COVERSCORE_H

#include <vector>
#include "../util/tallyvector.h"
#include "coverpoint.h"


class CoverScore
{
  public:

    inline void print () const
    {
      cout << (unsigned int)this << endl;
      m_tcover.print();
      m_ntcover.print();
    }

    bool operator>= ( const CoverScore & rhs ) const;

    void applyPoint ( const coverpoint_t & point );
    void unapplyPoint ( const coverpoint_t & point );

    void clear ();

    const CoverScore & operator+= ( const CoverScore & rhs );
    const CoverScore & operator-= ( const CoverScore & rhs );

    inline const std::vector< unsigned int > & targetCover () const
      { return m_tcover.getTallies(); }
    inline const std::vector< unsigned int > & nontargetCover () const
      { return m_ntcover.getTallies(); }

  private:

    TallyVector m_tcover, m_ntcover; // target, non-target
      // m_*cover[ i ] = # of points with i-coverage
};

#endif // COVERSCORE_H
