#ifndef BRUSH_H_
#define BRUSH_H_

#include <cmath>
#include <vector>
#include <string>
//#include <ftgl/FTFont.h>
#include "view.h"
#include "../geom/vec_2f.h"
#include "../geom/circle.h"
#include "../util/mathconsts.h"


class Brush
{
	public:
		Brush ( SDLGLview & canvas );
		~Brush ();

		void setRGBA ( const float r, const float g, const float b, const float a );

		void setA ( const float a );

		void setHSVA ( const float h, const float s, const float v, const float a );

		void drawSpot ( const vec_2f & center, const float radius ) const;

		void drawX ( const vec_2f & center, const float size ) const;

		void drawLineStrip ( const std::vector< vec_2f > & points ) const;

		void drawBox ( const rect_f & bound );

		void fillBox ( const rect_f & bound ) const;

		void fillHex ( const vec_2f & center, const float radius );

		void drawCircle ( const circle & circle ) const;

    struct barstyle_t
    {
      float r, g, b;
      rect_f sizepos; // will expand right
      float barwidth;
      bool bound;
      unsigned int hilight; // index of bar to hilight
    };
		void drawBarGraph ( const barstyle_t & style, const std::vector< float > & data );
			// take data[0] as maximum data value

		void print ( const vec_2f & pos, const std::string & text ) const;

	private:
		SDLGLview & m_canvas;
		float m_r, m_g, m_b, m_a;
		//FTGLPixmapFont font;

		GLuint m_dl_hexagon;
		GLuint m_dl_box;
};
#endif /*BRUSH_H_*/
