
#include "sdlmouse.h"


SDLMouse::SDLMouse ()
{
	s_cur.point = vec_2f( 0, 0 );
	s_cur.buttons = 0;
	updateState();
}


void SDLMouse::updateState ( const unsigned int timestamp )
{
	s_prev = s_cur;
	int x, y;
	s_cur.buttons = SDL_GetMouseState( &x, &y );
	s_cur.point = vec_2f( x, y );
  if( s_prev.buttons != s_cur.buttons )
  {
    click_t click;
    click.point = s_cur.point;
    click.buttons = s_cur.buttons;
    click.buttonchanges = s_cur.buttons ^ s_prev.buttons;
    click.timestamp = timestamp;
    m_clickq.push( click );
  }
}


bool SDLMouse::popClick ( click_t & click )
{
  if( m_clickq.empty() )
    return false;
  click = m_clickq.front();
  m_clickq.pop();
  return true;
}


void SDLMouse::clearEvents ()
{
  while( !m_clickq.empty() )
    m_clickq.pop();
}


const vec_2f & SDLMouse::getPoint () const
{
	return s_cur.point;
}


vec_2f SDLMouse::getMotion () const
{
	return s_cur.point - s_prev.point;
}


bool SDLMouse::buttonDown ( const Uint8 button ) const
{
	return s_cur.buttons & SDL_BUTTON( button );
}
