#ifndef POWERTABLE_H_
#define POWERTABLE_H_

#include <vector>

class PowerTable
{
	public:
		PowerTable ( const float base ) : m_base( base ) {}
		
		inline float operator() ( const unsigned int power )
		{
			if( m_powers.empty() )
				m_powers.push_back( 1.0 );
			while( m_powers.size() <= power )
				m_powers.push_back( m_powers.back() * m_base );
			return m_powers[ power ];
		}
		
	private:
		const float m_base;
		std::vector< float > m_powers;
};

#endif /*POWERTABLE_H_*/
