#ifndef TALLYVECTOR_H
#define TALLYVECTOR_H

#include <vector>

#include <iostream>
using namespace std;

class TallyVector
{
  public:

    void print () const;

    void incr ( const unsigned int i );
    void decr ( const unsigned int i );
    void set ( const unsigned int i, const unsigned int tally );
      // increment/decrement/set value i

    void clear ();

    const TallyVector & operator+= ( const TallyVector & rhs );
    const TallyVector & operator-= ( const TallyVector & rhs );

    inline const std::vector< unsigned int > & getTallies () const
      { return m_tallies; }

  private:

    std::vector< unsigned int > m_tallies;
};


#endif // TALLYVECTOR_H
